// Ionic Starter App

// angular.module is a global place for creating, registering and retrieving Angular modules
// 'starter' is the name of this angular module example (also set in a <body> attribute in index.html)
// the 2nd parameter is an array of 'requires'
// 'starter.services' is found in services.js
// 'starter.controllers' is found in controllers.js

var angularRoutingApp = angular.module('starter', ['ionic', 'starter.services', 'ngCordova', 'ion-gallery'])

  .run(function ($ionicHistory, $state, $ionicPlatform, $rootScope, $http/*, $cordovaSplashscreen*/) {

    $ionicPlatform.ready(function () {


      // Hide the accessory bar by default (remove this to show the accessory bar above the keyboard
      // for form inputs)
      if (window.cordova && window.cordova.plugins && window.cordova.plugins.Keyboard) {
        cordova.plugins.Keyboard.hideKeyboardAccessoryBar(true);
        cordova.plugins.Keyboard.disableScroll(true);
      }
      if (window.StatusBar) {
        // org.apache.cordova.statusbar required
        StatusBar.styleLightContent();
      }

      $ionicPlatform.registerBackButtonAction(function (event) {

        if ($state.current.name == "tab.Sintomas-cartilla") {
          //navigator.app.backHistory();
          //navigator.app.backHistory();
          $ionicHistory.goBack(-2);
        };
        if ($state.current.name == "tab.Biblioteca-cartilla") {
          //navigator.app.backHistory();
          $ionicHistory.goBack();
        };
        
        if ($state.current.name == "tab.Sintomas-images") {
          //navigator.app.backHistory();
          //navigator.app.backHistory();
          $ionicHistory.goBack();
        };
        if ($state.current.name == "tab.Biblioteca-images") {
          //navigator.app.backHistory();
          $ionicHistory.goBack();
        };
        
      /* if ($state.current.name == "tab.images") {
          //navigator.app.backHistory();
          $ionicHistory.goBack();
        };*/
        if ($state.current.name == "tab.Sintomas") {
          //navigator.app.backHistory();
          $ionicHistory.goBack();
        };
        if ($state.current.name == "tab.Biblioteca") {

        };
        if ($state.current.name == "tab.Acerca") {
          ionic.Platform.exitApp();
        };


      }, 100);
      
      // navigator.splashscreen.hide();
            
    });

    /*                    Metodos para generar toda la logica de las claves y poder traer la informacion de los archivo                  */

    $rootScope.listaDeCartillasYGuia = [];
    $rootScope.listaCartiilasMinima = [];
    $rootScope.CartillasOrdenada = [];
    var CartillasDesordenada = [];

    // Construictor del nodo del arbol 
    function tNodo(Id, Titulo, SubTitulo, Json, Imagenes, EsCartilla) {
      // body...
      this.id = Id;
      this.idPrevio = 0;
      this.titulo = Titulo;
      this.subTitulo = SubTitulo;
      this.opciones = "";
      this.jsonCartilla = Json;
      this.imagenes = Imagenes;
      this.esCartilla = EsCartilla;
    }

    // Metodo de nodo de arbol que devuelve las dos opciones
    tNodo.prototype.getOpciones = function () {
      return this.opciones;
    }
    // Metodo de nodo de arbol que devuelve las dos respuesta a las opciones
    tNodo.prototype.setOpciones = function (opcion) {
      this.opciones = opcion;
    }
    tNodo.prototype.setPrevio = function (id) {
      this.idPrevio = id;
    };
    tNodo.prototype.getPrevio = function () {
      return this.idPrevio;
    };

    /*          Manejo de archivos para leer los XML y pasarlos a nodos.      */

    // Metodo ajax leer archivo  --USAR ANGULAR SINO NO ANDA-- 
    function loadXML(file, callback) {
      $http.get(file)  //   "/js/prueba.xml"
        .success(function (data) {
          //console.log(data);
          var x2js = new X2JS();
          var json = x2js.xml_str2json(data);
          callback(json);
        });
    }

    function convertirCursivasSecciones(datos, callback) {
      var termino = false;
      for (var i = 0; i < datos.length; i++) {
        var contenido = datos[i].contenido;
        if (contenido != undefined || contenido != "") {
          var tipo = typeof contenido;
          if (tipo != "object") {
            if (tipo != "undefined") {
              contenido = contenido.replace(/#i/gi, "<i class='micursiva'>");
              contenido = contenido.replace(/i#/gi, "</i>");
              contenido = contenido.replace(/#n/gi, "<strong>");
              contenido = contenido.replace(/n#/gi, "</strong>");
              datos[i].contenido = contenido;
            };
          };
          if (tipo == "object") {
            convertirCursivasSecciones(contenido, function (contenidoConverido) {

              datos[i].contenido = contenidoConverido;

            })
          };

        };
        if ((i + 1) == datos.length) {
          termino = true;
          callback(datos);
        };
      };
    };

    function convertirCursivasPieImg(datos, callback) {
      for (var i = 0; i < datos.imagen.length; i++) {

        datos[i]

        var pie = datos.imagen[i].pie;
        pie = pie.replace(/#i/gi, "<i class='micursiva'>");
        pie = pie.replace(/i#/gi, "</i>");
        datos.imagen[i].pie = pie;

        if (i + 1 == datos.imagen.length) {
          callback(datos);
        };
      };
    }

    function convertirCursivasPreguntas(datos, callback) {
      for (var i = 0; i < datos.opcion.length; i++) {

        var texto = datos.opcion[i].textoOpcion;
        texto = texto.replace(/#i/gi, "<i class='micursiva'>");
        texto = texto.replace(/i#/gi, "</i>");
        datos.opcion[i].textoOpcion = texto;

        if (i + 1 == datos.opcion.length) {
          callback(datos);
        };
      };
    }

    function convertirCursivasTituloSeccion(datos, callback) {
      for (var i = 0; i < datos.length; i++) {

        var texto = datos[i].titulo;
        texto = texto.replace(/#i/gi, "<i class='micursiva'>");
        texto = texto.replace(/i#/gi, "</i>");
        datos[i].titulo = texto;

        if (i + 1 == datos.length) {
          callback(datos);
        };
      };
    }


    function auxCrearCartillas(index, datos, callback) {
      if (index == datos.documentos.cartilla.length) {
        callback();
      } else {
        var imagenes = datos.documentos.cartilla[index].imagenes;

        loadXML("xml/" + datos.documentos.cartilla[index].archivoTexto, function (datosNodo) {

          var id = datosNodo.cartilla.id;
          var titulo = datosNodo.cartilla.titulo.replace(/#i/gi, "<i class='micursiva'>");
          titulo = titulo.replace(/i#/gi, "</i>");

          var subTitulo = datosNodo.cartilla.subTitulo.replace(/#i/gi, "<i class='micursiva'>");
          subTitulo = subTitulo.replace(/i#/gi, "</i>");


          var secciones = datosNodo.cartilla.seccion;
          var titulosSecciones = datosNodo.cartilla.seccion;

          convertirCursivasTituloSeccion(titulosSecciones, function (datosConvertidos) {
            titulosSecciones = datosConvertidos;

          })


          convertirCursivasSecciones(secciones, function (datosConvertidos) {
            secciones = datosConvertidos;
            //var secciones = datosNodo.cartilla.seccion;
            convertirCursivasPieImg(imagenes, function (piesCover) {

              var cartilla = new tNodo(id, titulo, subTitulo, secciones, piesCover, true);

              $rootScope.listaDeCartillasYGuia.push(cartilla);
              //console.log($rootScope.listaDeCartillasYGuia);
              auxCrearCartillas(index + 1, datos, callback);

            });
          });
        });
      }
    }

    function auxCrearGuia(index, datos, callback) {
      if (index == datos.documentos.guia.length) {
        callback();
      } else {
        var idGuia = datos.documentos.guia[index].id;
        var idPrevio = datos.documentos.guia[index].previo;
        var opciones = datos.documentos.guia[index].opciones;
        var pregunta = datos.documentos.guia[index].pregunta;

        convertirCursivasPreguntas(opciones, function (opcionesCursiva) {
          var guia = new tNodo(idGuia, pregunta, "", "", "", false);
          guia.setPrevio(idPrevio);
          guia.setOpciones(opcionesCursiva);
          $rootScope.listaDeCartillasYGuia.push(guia);
          auxCrearGuia(index + 1, datos, callback);
        });
      }
    }
    function auxCargarGalerias(index, datos, callback) {
      if (index == datos.documentos.galeria.length) {
        callback();
      } else {

        var id = datos.documentos.galeria[index].id;
        var idImagenes = datos.documentos.galeria[index].cartillas;
        var opciones = [];
        var indexAux = 0;
        for (var i = 0; i < idImagenes.cartilla.length; i++) {

          $rootScope.obtenerNodoLista(idImagenes.cartilla[i], 0, function (nodo) {
            var opcion = [];
            opcion.push(nodo.imagenes.imagen[0].archivoImagen);
            opcion.push(idImagenes.cartilla[i]);
            opciones.push(opcion);
            if ((i + 1) == idImagenes.cartilla.length) {
              var galeria = new tNodo(id, "galeria", "", opciones, "", false);

              $rootScope.listaDeCartillasYGuia.push(galeria);
              auxCargarGalerias(index + 1, datos, callback);
            }
          });
        };
      }
    }
    // Metodo que va obteniendo de a uno los xml y va cargando los objetos creados a partir de estos en un array
    function crearCartillas() {

      loadXML("xml/estructura.xml", function (datos) {
        //console.log(datos);
        auxCrearCartillas(0, datos, function () {
          crearGuia();

        })

      });

    }

    function crearGuia() {
      loadXML("js/guia.xml", function (datos) {
        auxCrearGuia(0, datos, function () {

          $rootScope.obtenerCartillas(function (cartillas) {
            CartillasDesordenada = cartillas;
            ordenarCartillas(function (cartillasORD) {
              $rootScope.CartillasOrdenada = cartillasORD;
            });
          });
        });
        auxCargarGalerias(0, datos, function () {
          //aca termina todo
          //navigator.splashscreen.hide();
        });
      });
    }

    $rootScope.obtenerNodoLista = function (idAbuscar, index, callback) {
      if ($rootScope.listaDeCartillasYGuia.length > index) {
        if ($rootScope.listaDeCartillasYGuia[index].id == idAbuscar) {
          callback($rootScope.listaDeCartillasYGuia[index]);
        } else {
          $rootScope.obtenerNodoLista(idAbuscar, index + 1, callback);
        }
      } else {
        callback(undefined);
      }
    }

    $rootScope.obtenerCartillas = function (callback) {
      var array = [];
      for (var i = 0; i < $rootScope.listaDeCartillasYGuia.length; i++) {

        if ($rootScope.listaDeCartillasYGuia[i].esCartilla) {
          array.push($rootScope.listaDeCartillasYGuia[i]);
        };

        if ((i + 1) == $rootScope.listaDeCartillasYGuia.length) {
          callback(array);
        };
      };
    }

    function ordenarCartillas(callback) {

      CartillasDesordenada.sort(function (a, b) {
        return ((a.titulo < b.titulo) ? -1 : ((a.titulo > b.titulo) ? 1 : 0));
      })

      callback(CartillasDesordenada);


    }


    crearCartillas();

  });

angularRoutingApp.config(function ($stateProvider, $urlRouterProvider, $ionicConfigProvider) {

  // Ionic uses AngularUI Router which uses the concept of states
  // Learn more here: https://github.com/angular-ui/ui-router
  // Set up the various states which the app can be in.
  // Each state's controller can be found in controllers.js  
    
  $ionicConfigProvider.views.transition('none');
  $ionicConfigProvider.platform.android.views.transition('none');
  
  //$ionicConfigProvider.platform.ios.views.transition('none');

  $stateProvider

  // setup an abstract state for the tabs directive
    .state('tab', {
      // cache: false,
      url: '/tab',
      abstract: true,
      templateUrl: 'templates/tabs.html'
    })

  // Each tab has its own nav history stack:

    .state('tab.Biblioteca', {
      cache: false,
      url: '/biblioteca',
      views: {
        'tab-Biblioteca': {
          templateUrl: 'templates/tab-Biblioteca.html',
          controller: 'DashCtrl'
        }
      }
    })

    .state('tab.Sintomas', {
      cache: false,
      url: '/sintomas/:idsintoma',
      views: {
        'tab-Sintomas': {
          templateUrl: 'templates/tab-Sintomas.html',
          controller: 'SintomasCtrl'
        }
      }
    })
    .state('tab.Biblioteca-cartilla', {
      cache: false,
      url: '/biblioteca/:cartillaid',
      views: {
        'tab-Biblioteca': {
          templateUrl: 'templates/cartilla.html',
          controller: 'cartillaCtrl'
        }
      }
    })
    .state('tab.Sintomas-cartilla', {
      cache: false,
      url: '/sintomas/cartilla/:idsintoma',
      views: {
        'tab-Sintomas': {
          templateUrl: 'templates/cartilla.html',
          controller: 'cartillaCtrl'
        }
      }
    })
    .state('tab.Acerca', {
      cache: false,
      url: '/acerca',
      views: {
        'tab-Acerca': {
          templateUrl: 'templates/tab-Acerca.html',
          controller: 'AccountCtrl'
        }
      }
    })
  /* .state('tab.images', {
      cache: false,
      url: '/images/:cartillaid',
      views: {
        'tab-Biblioteca': {
          templateUrl: 'templates/images.html',
          controller: 'ImagesCtrl'
        }
      }
    })
*/
    .state('tab.Biblioteca-images', {
      cache: false,
      url: '/biblioteca/images/:cartillaid',
      views: {
        'tab-Biblioteca': {
          templateUrl: 'templates/images.html',
          controller: 'ImagesCtrl'
        }
      }
    })

    .state('tab.Sintomas-images', {
      cache: false,
      url: '/sintomas/images/:cartillaid',
      views: {
        'tab-Sintomas': {
          templateUrl: 'templates/images.html',
          controller: 'ImagesCtrl'
        }
      }
    })


    .state('splash', {
      cache: false,
      url: '/splash',
      templateUrl: 'templates/splash.html',
      controller: 'SplashCtrl'
    });

  // if none of the above states are matched, use this as the fallback
  
  $urlRouterProvider.otherwise('/splash');
});